//////////////////////////////////////////////////////////////////////
//vssDocLinks.js
//
// all parts not otherwise marked as being public domain are covered
// by the MPL version 1.1 and GPL version 2.
//
// At the time of this writing, no code from other authors is included,
// however, that may at some time change. If you locate any code which
// you believe was not dual-licensed under MPL version 1.1 and GPL version
// 2, or you believe a segment of code was left uncredited, neither
// license applies and you are NOT GRANTED any distribution right. This
// is NOT an additional term, merely a re-stating of things already
// covered in the MPL and GPL (in short, this code would be in violation
// of the MPL and GPL, and so you would not have any license to
// distribute this code). If you find any evidence of this
// (unlicensed or uncredited code), contact thebitman@comcast.net
// IMMEDIATELY.
//
// Note that this would not take away any of your rights on the parts
// labeled as being in the public domain, unless the part in question
// is where the error occured.
//
//Though the function headers are generally made to wrap at 70-80 cols,
//the code itself is made to wrap at 120 cols. (tabstop=4spcs)
//It's done for a very good reason which is rendered entirely moot
//by my lack of commenting what it is the functions actually do.
//That issue is somewhat moot too, though, since the whole thing is
//very simple.
//
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
function vssdl_init() {
//////////////////////////////////////////////////////////////////////
	window.top.addEventListener("load", vssdl_content_onload, true);
	return;
}
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
function vssdl_destroy() {
//////////////////////////////////////////////////////////////////////
	window.top.removeEventListener("load", vssdl_content_onload, true);
	return;
}
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
function vssdl_content_onload(event) {
//////////////////////////////////////////////////////////////////////

	if (	event.target.getAttribute &&
			event.target.getAttribute("id") == "content" ) {
		if (window._content.document.getElementsByTagName("a").length > 0 && //No need to load if thar aint any nodes
			window.document.getElementById('vssdlAL').getAttribute("checked") ) { //or if we said not to
			vssdl_loadLinks();
		} else {
			var lns = window.document.getElementById('vssdlListbox');
			var i;
			var maxIndex = lns.getRowCount()-1;

			var ext = /.*(\..*)$/;
			ext = ext.exec(window._content.document.location)[1];
			
			for (i = 0; i<=maxIndex; i++) {
				if (lns.getItemAtIndex(i).value == window._content.document.location) {
					lns.ensureIndexIsVisible(i);
					lns.selectItem(lns.getItemAtIndex(i));

					if (window.document.getElementById('vssdlAF').getAttribute("checked")) {
						window.document.getElementById('vssdlHrefFilter').value = "/"+ext+"$/i";
						vssdl_filterLinks(0);
						window.document.getElementById('vssdlHrefFilter').value = "";
					}
					break;
				}
			}
		}
    }
}
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
function vssdl_selectCurrent() { //Selects the currently-loaded URL, if it's on the list
//////////////////////////////////////////////////////////////////////
	var i;
	var lns = window.document.getElementById('vssdlListbox');
	var maxIndex = lns.getRowCount()-1;
//////////////////////////////

	for (i = 0; i<=maxIndex; i++) {
		if (lns.getItemAtIndex(i).value == window._content.document.location) {
			lns.ensureIndexIsVisible(i);
			lns.selectItem(lns.getItemAtIndex(i));
			break;
		}
	}

	return;
}
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
function vssdl_loadLinks() {
//////////////////////////////////////////////////////////////////////
	var lns, links, link, newList;
	var i;
	var strLinkText;
	
	lns = window.document.getElementById('vssdlListbox');
	links = window._content.document.getElementsByTagName("a");
//////////////////////////////////////////////////////////////////////

	//Old links are cleared here (this seems fast enough)
	newList = window.document.createElement("listbox");
	newList.flex = "1";
	newList.id = "vssdlListbox";

	lns.parentNode.replaceChild(newList, lns);
	lns = newList;

	for (i = 0; i < links.length; i++) {
		link = links[i];
		if (link.href.length > 0) {
			//Links are added to the list here
			strLinkText = vssdl_cleanText(link.text);
			if (strLinkText.length == 0 && link.getElementsByTagName("img").length)  {
				strLinkText = "[img] " + link.getElementsByTagName("img")[0].src;
			}
			link = lns.appendItem ( "> " + strLinkText, link.href );
			link.addEventListener ("dblclick", vssdl_LezGo, true);
		}
	}

	//A link to the original page is always in the list (even when filtered)
	link = lns.appendItem ( "> [Original Page]", window._content.document.location );
	link.addEventListener ("dblclick", vssdl_LezGo, true);
	
	return;
}

//////////////////////////////////////////////////////////////////////
function vssdl_LezGo() { //When you double-click a link (*dear god I suck)
//////////////////////////////////////////////////////////////////////

	vssdl_loadURI(this.value,this.parentNode.lastChild.value);
	return;
}
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
function vssdl_loadURI() {
//////////////////////////////////////////////////////////////////////
	var argv = vssdl_loadURI.arguments;
	var ref, url;
	url = ref = null;
//////////////////////////////
	switch(argv.length) {
		case 2: ref = vssdl_create_nsIURI(argv[1]);
		case 1: url = argv[0];
		default: break;
	}

	vssdl_mostRecentBrowser().webNavigation.loadURI(
						url,															//URL (unicode)
						Components.interfaces.nsIWebNavigation.LOAD_FLAGS_IS_LINK,		//"Send the Referer"
						ref,															//Definition of the referer
						null,															//POST data (nsIInputStream)
						null);															//Additional Headers (nsIInputStream)
	return;	
}
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
function vssdl_filterLinks(whichFilter) { //0 = href, 1 = text, 2 = both
//////////////////////////////////////////////////////////////////////
	var hl,tl;
	var lns, link;
	
	lns = window.document.getElementById('vssdlListbox');
	tl = vssdl_reFromString(window.document.getElementById('vssdlTextFilter').value);
	hl = vssdl_reFromString(window.document.getElementById('vssdlHrefFilter').value);
//////////////////////////////
	
	for (i = 0; i < (lns.getRowCount()-1); i++) {
		link = lns.getItemAtIndex(i);
		
		if (whichFilter == 0 || whichFilter == 2) {
			if (hl != null && !link.value.substr(2).match(hl)) {
				lns.removeItemAt(i);
				i--;
			}
		}

		if (whichFilter == 1 || whichFilter == 2) {
			if (tl != null && !link.label.substr(2).match(tl)) {
				lns.removeItemAt(i);
				i--;
			}
		}
	}
		
	return;
}
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
function vssdl_nextLink() {
//////////////////////////////////////////////////////////////////////
	var lns;
	var maxIndex;

	lns = window.document.getElementById('vssdlListbox');
	maxIndex = lns.getRowCount()-1;
//////////////////////////////
	
	vssdl_selectCurrent();
	
	if (lns.selectedCount < 1) {
		lns.selectItem( lns.getItemAtIndex(0) );
	} else if (lns.selectedIndex < maxIndex) {
		lns.selectItem( lns.getItemAtIndex(lns.selectedIndex+1) );
	} else {
		lns.selectItem( lns.getItemAtIndex(0) );
	}

	vssdl_loadURI(lns.selectedItem.value,lns.lastChild.value);
	
	return;
}
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
function vssdl_previousLink() {
//////////////////////////////////////////////////////////////////////
	var lns;
	var maxIndex;

	lns = window.document.getElementById('vssdlListbox');
	maxIndex = lns.getRowCount()-1;
//////////////////////////////

	vssdl_selectCurrent();

	if (lns.selectedCount < 1) {
		lns.selectItem( lns.getItemAtIndex(maxIndex - 1) );
	} else if (lns.selectedIndex > 0) {
		lns.selectItem( lns.getItemAtIndex(lns.selectedIndex-1) );
	} else {
		lns.selectItem( lns.getItemAtIndex(maxIndex) );
	}
	vssdl_loadURI(lns.selectedItem.value,lns.lastChild.value);
	
	return;
}
//////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////
//I'm lazy, here's a one-liner because I dont want to type something twice.
//////////////////////////////////////////////////////////////////////
function vssdl_cleanText(text) { return vssdl_trim(text).replace(/[\r\n]+/g,""); }
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
//Support Functions (can be transplanted with ease- the ones below are
//                   Public Domain!)
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
function vssdl_mostRecentBrowser() { //I'm still lazy.
//////////////////////////////////////////////////////////////////////
//This one's because I dont understand this whole Components.classes
//thing and it took me too long to look up that window-mediator string.
//////////////////////////////////////////////////////////////////////
	return Components.classes["@mozilla.org/appshell/window-mediator;1"]
				.getService(Components.interfaces.nsIWindowMediator)
				.getMostRecentWindow("navigator:browser")
				.getBrowser();
}
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
function vssdl_create_nsIURI() { //str URL, Charset, nsIURI BaseURI
//////////////////////////////////////////////////////////////////////
	var argv = vssdl_create_nsIURI.arguments;
	var URL, Charset, BaseURI;
	URL = Charset = BaseURI = null;
	
	switch(argv.length) {
		case 3:
			BaseURI = argv[2];
		case 2:
			Charset = argv[1];
		case 1:
			URL = argv[0];
		break;
		
		default: break;
	}
			
	return	Components.classes["@mozilla.org/network/io-service;1"]
				.getService(Components.interfaces.nsIIOService)
				.newURI(URL, Charset, BaseURI);
}
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
function vssdl_reFromString(source) {
//////////////////////////////////////////////////////////////////////
	var re, m;
//////////////////////////////
	if (source == null || source.length == 0) { return null; }
	re = /^\/.*\/.*$/;
	if (source.match(re)) {
		re = new RegExp("^\/(.*)\/([^\/]*)$");
		m = re.exec(source);
		re = new RegExp(m[1],m[2]);
	} else {
		re = new RegExp(source);
	}
	return re;
}
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
function vssdl_trim(text) {
//////////////////////////////////////////////////////////////////////
	text = text.replace(/^\s*/, "");
	text = text.replace(/\s*$/, "");
	return text;
}
//////////////////////////////////////////////////////////////////////
